
angular.module('updates',['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])

    .controller('UpdateCtrl', ['$scope', '$rootScope', '$http', 'AssetService', 'ngDialog', function($scope, $rootScope, $http, AssetService, ngDialog) {

        $scope.initCtrl = function (dlg) {

            $scope.updates = $scope.ngDialogData;

            var $form = $("#form_updates"),
                $updateTable = $("#system-update-table"),
                updatesForm,
                UpdateTable;

                $form.find(".definition").popover({
                    appendTo: $form,
                    position: {
                        my: "left center",
                        at: "right+10 center",
                        collision: "flip fit",
                        within: $form
                    }
                });

                var cellFormatter = {
                    preCheck: function(value, row) {
                        var displayStatus = row.preCheck;
                        var iconClass = "";
                        var displayTitle = "";
                        var toolTip;
                        var html;
                        var iconColor = "green";
                        if (displayStatus.substring(0,2) === 'No') {
                            iconClass = "exclamationsign";
                            displayTitle = "";
                            iconColor = "red";
                            toolTip = displayStatus.substring(3);
                            toolTip = toolTip || displayTitle;
                            html =  '<i class="icon-'+iconClass + ' icon-large help-trigger" style="color:' + iconColor + ';margin-right:2px;"></i>' +
                                '<span  class = "definition" >' +toolTip + '</span>';
                        }
                        else if(displayStatus.substring(0,3) === "Yes" ){
                            if(row.count > 0){
                                html = " <input class=\"ngdialog-button\" type=\"submit\" value=\"&nbsp; Apply Update &nbsp;\"/>";
                            }
                            else{
                                iconClass = "okcircle";
                                toolTip = "This appliance is up to date";
                                html =  '<i class="icon-'+iconClass + ' icon-large help-trigger" style="color:' + iconColor + ';margin-right:2px;"></i>' +
                                '<span  class = "definition" >' +toolTip + '</span>';
                            }
                        }

                        return html;
                    }
                };

                UpdateTable = PHD.DataTable($updateTable, {
                    dynamic: false,
                    tableScrollOptions: {"height": "article"},
                    select: true,
                    sortable: true,
                    sortOnLoad: true,
                    sortOnHeader: true,
                    integerIDs: false,
                    cellClasses: [null, null, "full-text"],
                    classifiers: ['id']

                }).registerFormatters(cellFormatter);

                updatesForm = PHD.FormController($form, {});

                loadUpdates();

                function loadUpdates() {
                    var data = $scope.updates.data;
                    var updateSystems = [];
                    data.forEach(function(item,index){
                        var obj = {};
                        obj.count = item.count;
                        obj.sname = item.sname;
                        obj.id = item.sid;
                        obj.preCheck = item.preCheck;
                        updateSystems.push(obj);
                    });
                    UpdateTable.load(updateSystems);
                }

                $("#system-update-table").on("rowselect", "tr", function (event, dbid, $el, DataTable, DataRow) {
                    var UpdateSystem = DataRow.data;
                    $scope.id = UpdateSystem.id;
                });


                $("#system-update-table").on("click", "input", function(event,dbid, $el, DataTable, DataRow) {
                    console.log("Row button clicked");
                    console.log($scope.id);
                    var load = PHD.showLoadingIndicator("body", true, "Appliance is updating, do not reboot...");

                    console.log('appliance id is ' + $scope.id);
                    var url_sid = ( $scope.id === null) ? "" : "/?sid=" +  $scope.id;
                    var url = "/api/updates";
                    url += url_sid;
                    console.log("URL is " + url);
                    PHD.Ajax
                        .post(url, null, load, handleError)
                        .done(function (data) {
                            console.log("in .done after post" + data);
                        })
                        .always(function () {
                            PHD.hideLoadingIndicator(load);
                        });

                    return this;
                });

                $form.find(".definition").popover({
                    appendTo: $form
                });

            };

            function handleError(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status === 500) {
                    var data = jqXHR.responseJSON;
                    if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                        var message = data.result[0].message;
                        PHD.throwNotice(data);
                    } else {
                        PHD.throwError(data);
                    }
                } else {
                    PHD.Ajax.ajaxError(jqXHR, textStatus, errorThrown);
                }
            }


            // Initialize the controller.
            $scope.$on('ngDialog.opened', function (event, obj) {
                $scope.initCtrl(obj)
            });

    }]);


